gi-gsk-4.0.9: Gsk bindings

Copyright | Will Thompson and Iñaki García Etxebarria
License | LGPL-2.1
Maintainer | Iñaki García Etxebarria
Safe Haskell | None
Language | Haskell2010

GI.Gsk.Objects.ShadowNode

Contents

- Exported types
- Methods
  - getChild
  - getNShadows
  - getShadow
  - new

Description

A render node drawing one or more shadows behind its single child node.

Synopsis

- newtype ShadowNode = ShadowNode (ManagedPtr ShadowNode)
- class (BoxedPtr o, TypedObject o, IsDescendantOf ShadowNode o) => IsShadowNode o
- toShadowNode :: (MonadIO m, IsShadowNode o) => o -> m ShadowNode
- shadowNodeGetChild :: (HasCallStack, MonadIO m, IsShadowNode a) => a -> m RenderNode
- shadowNodeGetNShadows :: (HasCallStack, MonadIO m, IsShadowNode a) => a -> m CSize
- shadowNodeGetShadow :: (HasCallStack, MonadIO m, IsShadowNode a) => a -> CSize -> m Shadow
- shadowNodeNew :: (HasCallStack, MonadIO m, IsRenderNode a) => a -> [Shadow] -> m ShadowNode

# Exported types

newtype ShadowNode Source #

Memory-managed wrapper type.

Constructors

ShadowNode (ManagedPtr ShadowNode) |

#### Instances

Instances details

Eq ShadowNode Source # |
Instance details Defined in GI.Gsk.Objects.ShadowNode Methods (==) :: ShadowNode -> ShadowNode -> Bool Source # (/=) :: ShadowNode -> ShadowNode -> Bool Source #
BoxedPtr ShadowNode Source # |
Instance details Defined in GI.Gsk.Objects.ShadowNode Methods boxedPtrCopy :: ShadowNode -> IO ShadowNode Source # boxedPtrFree :: ShadowNode -> IO () Source #
ManagedPtrNewtype ShadowNode Source # |
Instance details Defined in GI.Gsk.Objects.ShadowNode Methods toManagedPtr :: ShadowNode -> ManagedPtr ShadowNode Source #
TypedObject ShadowNode Source # |
Instance details Defined in GI.Gsk.Objects.ShadowNode Methods glibType :: IO GType Source #
HasParentTypes ShadowNode Source # |
Instance details Defined in GI.Gsk.Objects.ShadowNode
type ParentTypes ShadowNode Source # |
Instance details Defined in GI.Gsk.Objects.ShadowNode type ParentTypes ShadowNode = '[RenderNode]

class (BoxedPtr o, TypedObject o, IsDescendantOf ShadowNode o) => IsShadowNode o Source #

Type class for types which can be safely cast to `ShadowNode`, for instance with `toShadowNode`.

#### Instances

Instances details

(BoxedPtr o, TypedObject o, IsDescendantOf ShadowNode o) => IsShadowNode o Source # |
Instance details Defined in GI.Gsk.Objects.ShadowNode

toShadowNode :: (MonadIO m, IsShadowNode o) => o -> m ShadowNode Source #

Cast to `ShadowNode`, for types for which this is known to be safe. For general casts, use `castTo`.

# Methods

### Click to display all available methods, including inherited ones

Expand

#### Methods

draw, ref, serialize, unref, writeToFile.

#### Getters

getBounds, getChild, getNShadows, getNodeType, getOpaqueRect, getShadow.

#### Setters

None.

## getChild

shadowNodeGetChild Source #

Arguments

:: (HasCallStack, MonadIO m, IsShadowNode a) |
=> a | `node`: a shadow `GskRenderNode`
-> m RenderNode | Returns: the child render node

Retrieves the child `GskRenderNode` of the shadow `node`.

## getNShadows

shadowNodeGetNShadows Source #

Arguments

:: (HasCallStack, MonadIO m, IsShadowNode a) |
=> a | `node`: a shadow `GskRenderNode`
-> m CSize | Returns: the number of shadows.

Retrieves the number of shadows in the `node`.

## getShadow

shadowNodeGetShadow Source #

Arguments

:: (HasCallStack, MonadIO m, IsShadowNode a) |
=> a | `node`: a shadow `GskRenderNode`
-> CSize | `i`: the given index
-> m Shadow | Returns: the shadow data

Retrieves the shadow data at the given index `i`.

## new

shadowNodeNew Source #

Arguments

:: (HasCallStack, MonadIO m, IsRenderNode a) |
=> a | `child`: The node to draw
-> [Shadow] | `shadows`: The shadows to apply
-> m ShadowNode | Returns: A new `GskRenderNode`

Creates a `GskRenderNode` that will draw a `child` with the given `shadows` below it.